<?php
// $Id: blog_mime_create.inc,v 1.2 2004/10/26 15:58:00 javanaut Exp $
/**
 * Implementation of blog's mime_create hook for use by the mime_registry module.
 * 
 */
function blog_mime_create($newnode) {
  //drupal_set_message('blog_mime_create hook called.  It has not been implemented yet, so there is no node created');
  
  // see if $newnode->title and $newnode->body are proper and valid
  if(strlen(trim($newnode->body)) == 0) {
    return array();
  }
  
  // make up a default title using body
  if(strlen($newnode->title) == 0) {
    $newnode->title = substr(strip_tags($newnode->body), 0, 30);
  }
  else {
    $newnode->title = strip_tags($newnode->title);
  }
  
  // if body was all tags for some reason...
  if(strlen($newnode->title) == 0) {
    $newnode->title = t('[no title]');
  }
  
  $newnode->teaser = $newnode->body; // testing here
  
  if (node_access('create', $newnode)) {
    $newnode->nid = node_save($newnode);
    watchdog('special', t('%type: added %title via mime_create.', array('%type' => '<em>'. t($newnode->type) .'</em>', '%title' => "<em>$newnode->title</em>")), l(t('view'), "node/$newnode->nid"));
  }
  
  return array($newnode);
}

?>
