<?php
// $Id: filestore2_mime_create.inc,v 1.2 2004/10/26 15:58:00 javanaut Exp $
/**
 * Implementation of filestore2's mime_create hook for use by the mime_registry module.
 * 
 */
function filestore2_mime_create($node) {
  global $user;
  $node->teaser = $node->filename;
  $node->body = $node->filename;
  $node->version = 1;
  $node->author = $user->name;
  $node->filetype = $node->content_type;
  $node->type = 'filestore2';
  
  if(isset($node->filename)) {
    $node->title = $node->filename;
  }

  if ($node->data) {
    drupal_set_message("Accepted filestore2 file '$node->filename' (title:'$node->title') of acceptable MIME type ($node->filetype).");

    // if there's something to save, do so now
    // * * * * SAVE THIS TO A FILE AND SET THE PROPER NODE VALUES!!! * * * *

    if(($tmp_file = _filestore2_mime_create_write_tmp_file($node)) === false) {
      // complain about the failure
      drupal_set_message("Failed to write to temp file '$tmp_file' in filestore2_mime_create()..");
      return array();
    }
    
    // move $tmp_file to fscache
    $node->fsid = fscache_add_move_file($tmp_file, 0, $node->type, true);
    
    // "fid", "nid", "fsid", "version", "author", "url"
    
    $node->nid = node_save($node);
    return array($node);
  }

  return array();
}

/** Writes $node->data to an appropriate temp file */
function _filestore2_mime_create_write_tmp_file($node) {
  // use tempfile format that PHP's is_uploaded_file(..) function suggests
  if (!$tmp_file = get_cfg_var('upload_tmp_dir')) {
    $tmp_file = dirname(tempnam('', ''));
  }
  $tmp_file .= '/' . basename($node->filename);

  $handle = false;
  //if(!file_exists($tmp_file) && !$handle = fopen($tmp_file, 'wb')) {
  if(!$handle = fopen($tmp_file, 'wb')) {
    drupal_set_message("ERROR: failed to create image file '".$tmp_file."'.  Skipping..");
    return false;
  }
  if($handle) {
    if(fwrite($handle, $node->data, strlen($node->data)) === false) {
      drupal_set_message("ERROR: failed to write to file '".$tmp_file."'.  Skipping..");
      fclose($handle);
      return false;
    }
    fclose($handle);
  }
  else {
    drupal_set_message("ERROR: couldn't open $tmp_file for writing, but handle was not null");
  }
return $tmp_file;
}

?>
