<?php
/**
 * Implementation of filestore's mime_create hook for use by the mime_registry module.
 * 
 */
function filestore_mime_create($newnode) {
  $newnode->teaser = $newnode->filename;
  $newnode->body = $newnode->filename;
  $newnode->version = 1;
  $newnode->fileauthor = $newnode->name;
  $newnode->filetype = $newnode->content_type;
  $newnode->type = 'filestore';
  
  if(isset($newnode->filename)) {
    $newnode->title = $newnode->filename;
  }

  if (!_filestore_mimetype_allowed($newnode->filetype)) {
    drupal_set_message("Rejected file '$newnode->filename' because it is not one of filestore's acceptable MIME types ($newnode->filetype).");
    // just skip the offending file
    return array();
  }
  elseif ($newnode->data) {
    drupal_set_message("Accepted file '$newnode->filename' (title:'$newnode->title') of acceptable MIME type ($newnode->filetype).");

    // if there's something to save, do so now
    $newnode->filesize = strlen($newnode->data);
    $newnode->filedata = base64_encode($newnode->data);
    $newnode->nid = node_save($newnode);
    return array($newnode);
  }

  return array();
}

?>
