<?php
// $Id: image_mime_create.inc,v 1.3 2004/10/26 15:58:00 javanaut Exp $
/**
 * Implementation of image module's mime_create hook for use by the mime_registry module.
 * Currently, only JPEG, GIF and PNG are supported
 * 
 */
function image_mime_create($newnode) {
  global $_FILES;
  
  // TODO: FINISH ME NOW, MSH!
  // setup a taxonomy for today's date under the moblog vocabulary if it doesn't exist yet:
  // Post-Refactor update: this should be in the moblog.module -MSH
  $vid = variable_get("image_mime_create_vocab", "");
  if(!$newnode->taxonomy && $vid != "") {
    $yr=date("Y");
    $mo=date("m");
    $da=date("d");

    // get/create year term
    $res = taxonomy_get_term_by_name($yr);
    if(!sizeof($res)) {
      $yr_term = taxonomy_save_term(array('name'=>$yr, 'vid'=>$vid, 'description'=>'year image was posted'));
      $yr_tid = $yr_term['tid'];
    }
    else {
      $yr_tid = $res[0]->tid;
    }

    // find/create month term
    $mo_children = taxonomy_get_children($yr_term->tid);

    // find/create day term

    // assign day term to new node
  }

  // for now, just stick the new moblog images under a hard-coded term
  //$newnode->taxonomy = explode(',', variable_get("image_mime_create_default_term","4"));

  //print "newnode passed in to image_mime_create (notice no data key):<pre>\n"; var_dump($newnode); print "</pre>";
  if(!isset($newnode->personal)) {
    $newnode->personal = 0;
  }
  if(!isset($newnode->promote)) {
    $newnode->promote = 1;
  }
  $newnode->type = 'image';
  
  if(!$newnode->title) {
    $newnode->title = $newnode->filename;
  }
  if(!$newnode->title) {
    $newnode->title = 'image';
  }

  // image mod likes to prefix extenstion with a dot.
  if($newnode->extension) {
    $newnode->extension = "." . $newnode->extension;
  }

  // accommodate new upload.module check
  $newnode->files = array();
  
  // write $newnode->data to a file in image_tmpdir
  if(!$newnode->filename) {
    // make something up
    $filename = "randimg_".rand();
    if($newnode->extension) {
      $filename .= $newnode->extension;
    }
    else {
      switch(strtolower($newnode->content_type)) {
        case("image/gif"):
          $newnode->extension .= ".gif";
          break;

        case("image/jpeg"):
        case("image/jpg"):
          $newnode->extension .= ".jpg";
          break;

        case("image/png"):
          $newnode->extension .= ".png";
          break;
      }
      $filename .= $newnode->extension;
    }
    
    $newnode->filename = $filename;
  }


  $tmp_file = variable_get('image_temp_path', './') . 'tmpimg_' . basename($newnode->filename);

  
  $handle = false;
  if(!$handle = fopen($tmp_file, 'wb')) {
    drupal_set_message("ERROR: failed to create temp image file '".$tmp_file."'.  Skipping..");
    return array();
  }
  if($handle) {
    if(fwrite($handle, $newnode->data, strlen($newnode->data)) === false) {
      drupal_set_message("ERROR: failed to write to temp file '".$tmp_file."'.  Skipping..");
      fclose($handle);
      return array();
    }
    fclose($handle);
  }
  else {
    drupal_set_message("ERROR: couldn't open $tmp_file for writing, but handle was not null");
  }
  

  /* * * VALIDATE * * */
  $newnode->image_list = array();
  if(_image_validate_uploaded_file($newnode, $tmp_file, $newnode->filename)) {

    // The following blocks of code were copied directly from image.module
    
    // Save off image information.

    $newnode->iptc = $newnode->image_details['iptc_info'];
    $newnode->exif = image_get_exif($newnode->image_path);
    $newnode->img_format = strtolower($newnode->image_details['type']);
    $newnode->width = $newnode->image_details['width'];
    $newnode->height = $newnode->image_details['height'];
    $newnode->filesize = filesize($newnode->image_path);

    // Generate new thumbnail.

    $newnode->thumb_path = _image_tempthumbname($newnode);
    $errortxt = _image_make_thumbnail($newnode->image_path, $newnode->thumb_path);
    if ($errortxt) {
      form_set_error('image', $errortxt);
    }

    // Build additional static images.
    // Add to image_list any default resolutions that are missing.

    foreach (variable_get('image_static_resolution', array('640x480')) as $v) {
      if (!array_key_exists($v, $newnode->image_list)) {
        $newnode->image_list[$v] = '';
      }
    }

    // Scale image to other static sizes.

    foreach ($newnode->image_list as $k => $v) {
      $fname = _image_make_static($newnode, $k);
      if ($fname) {
        $newnode->image_list[$k]['fname'] = $fname;
      }
    }

  }
  
  /* * * SAVE * * */
  $newnode->nid = node_save($newnode);

  // no new child nodes created, so return an empty array.
  return array($newnode);
}

?>
